// This script found on http://www.din.or.jp/~koryan/sonic/gbs_ca.htm
// Credit and copywrite go to Koji Nishio, not me (DrSpud).
// Images can be found at http://cgi.din.or.jp/~koryan/sonic/gbs/map/
// Note that I corrected the pics for section 006 & made a number of
// enhancements. Major or significant changes are marked with comments
// in english.

// Any questions/comments about my version/implementation of this,
// feel free to email me: DrSpud at mad dot scientist dot com

	//////////////////////////////////////////////////////////////////
	// Copyright(C) Koji NISHIO (Koryan) 2003 all rights reserved.	//
	// f]ڌցII						//
	//////////////////////////////////////////////////////////////////

/* ̏Z(_ȉ؂̂)̊֐ div */
function div(a,b)
{
	return Math.floor(a / b);
}


/* ͐l킩ǂ`FbN֐ numcheck */
function numcheck(numr,numi,MIN,MAX)
{
	chk = 0;

	//  numr == "" seems to be true in Firefox when it's 0, hence the '==='.
	if ( numr === "" || isNaN(numr) || numi < MIN || numi > MAX || (numi != numr) )
	{
		window.alert("Enter a number from " + MIN + " to " + MAX);
		chk = 1;
	}
	return chk;
}


/* xR[hԍ𓱏o֐ levtocod */
function levtocod(lev)
{

  /* PFݒ */
	ca = new Array(39);	//R[hԍvZ邽߂̂Qi(39)
	cb = new Array(28);	//xQiɂ邽߂̂Qi(28)
	cc = new Array(0,0,0);	//ŏII10iR[hԍi[
	var tmp;

	ca[38] = 1;

  /* QFQi(32)`(27)ځA(21)`(1)ڂ߂ */

    //ux{19,088,742vQiɕϊ
	tmp = lev + 19088742;

	for (i = 0; i <= 27; i++)
	{
		cb[i] = tmp % 2;
		tmp = div(tmp,2);
	}

    //̂Qi(ʒuς)QiR[hɊi[
	for (i = 0; i <= 5 ; i++)
		ca[i+26] = cb[i];
	for (i = 6; i <= 26; i++)
		ca[i-6] = cb[i];

  /* RFQi(38)`(33)ځA(26)`(22)ڂ߂ */

    //ux|PvQiɕϊ
	tmp = lev - 1;

	for (i = 0; i <= 27; i++)
	{
		cb[i] = tmp % 2;
		tmp = div(tmp,2);
	}

    //̖@ɏ]ĂQiR[h쐬
	ca[37] = ( 1 + cb[6] + cb[23] ) % 2;
	ca[36] = ( 1 + cb[5] + cb[22] + cb[17] + cb[0] ) % 2;
	ca[35] = ( 1 + cb[4] + cb[21] + cb[16] ) % 2;
	ca[34] = ( 1 + cb[3] + cb[20] ) % 2;
	ca[33] = ( 1 + cb[2] + cb[19] ) % 2;
	ca[32] = ( 1 + cb[1] + cb[18] ) % 2;

	ca[25] = ( 0 + cb[11] + cb[16] ) % 2;
	ca[24] = ( 0 + cb[10] ) % 2;
	ca[23] = ( 0 + cb[9] + cb[26] ) % 2;
	ca[22] = ( 0 + cb[8] + cb[25] ) % 2;
	ca[21] = ( 0 + cb[7] + cb[24] ) % 2;

  /* SFŏIIȃR[hԍ߂ */
    //rbg]
	for (i = 1; i < 38; i = i+2)
		ca[i] = 1 - ca[i];

    //R[hԍ쐬
	for (i = 38; i >= 0; i--)
	{
		tmp = ca[i];
		for (j = 0; j <= 2; j++)
		{
			cc[j] = cc[j] * 2 + tmp;
			if ( cc[j] > 9999 )
			{
				tmp = 1;
				cc[j] -= 10000;
			}
			else tmp = 0;
		}
	}

    //킹(R[hԍ(0000`9999)Sɑĕɂ)
	for (i = 0; i <= 2; i++)
	{
		if      (cc[i] < 10)
			cc[i]="000" + cc[i];
		else if (cc[i] < 100)
			cc[i]="00"  + cc[i];
		else if (cc[i] < 1000)
			cc[i]="0"   + cc[i];
		else
			cc[i]=""    + cc[i];
	}

	//removed hyphens, not needed
	cod = "" + cc[2] + " " + cc[1] + " " + cc[0];
	return cod;
}


/* x畔}bvԍ𓱏o֐ levtopmn */
function levtopmn(lev)
{
	pmn = new Array(4);

	pmn[0] = (lev - 1) % 128;
	pmn[1] = (1 + ((lev - 1) % 127) * 3) % 127;
	pmn[2] = (2 + ((lev - 1) % 126) * 5) % 126;
	pmn[3] = (3 + ((lev - 1) % 125) * 7) % 125;

	return pmn;
}


/* }bvԍXe[Wԍ𓱏o֐ pmntostg */
function pmntostg(pmn)
{
	stg = 0;

	for (i = 0; i <= 3; i++)
		stg = stg * 128 + pmn[i];

	return stg;
}


/* Xe[Wԍ畔}bvԍ𓱏o֐ stgtopmn */
function stgtopmn(stg)
{
	pmn = new Array(4);

	for (i = 3; i >= 0; i--)
	{
		pmn[i] = stg % 128;
		stg = div(stg, 128);
	}

	return pmn;
}


/* }bvԍ瑊x𓱏o֐ pmntolev */
function pmntolev(pmn)
{
	lev = pmn[0] + 1;
	jug = 0;
	var tmp;

    //xɕϊł邩ǂ
	if ( pmn[1] > 126 || pmn[2] > 125 || pmn[3] > 124)
		jug = 1;
	if ( (pmn[0] + pmn[2]) % 2 != 0 )
		jug = 1;  //[0][2]̋vȂƃ_

	if (jug == 0)
	{
		pmnb = levtopmn(lev);
	    //RR܂ł [0] v

		if (pmn[1] < pmnb[1]) pmn[1] += 127;
		tmp = ( pmn[1] - pmnb[1] ) % 3;
		if (tmp != 0) pmn[1] += 127 * (3 - tmp);
		lev += 128 * ((pmn[1] - pmnb[1]) / 3);
		pmnb = levtopmn(lev);
	    //RR܂ł [0] [1] v

		if (pmn[2] < pmnb[2]) pmn[2] += 126;
		tmp = ( pmn[2] - pmnb[2] ) % 5;
		if (tmp != 0) pmn[2] += 126 * (5 - tmp);
		lev += 128 * 127 * ((pmn[2] - pmnb[2]) / 10);
		pmnb = levtopmn(lev);
	    //RR܂ł [0] [1] [2] v

		tmp = 0;
		while (pmn[3] != pmnb[3]){
			pmn[3] -= 21;
			if ( pmn[3] < 0 ) pmn[3] += 125;
			tmp++;
		}
		lev += 128 * 127 * 63 * tmp;
		pmnb = levtopmn(lev);
	    //RR܂ł [0] [1] [2] [3] SĈvnY
	}
	else lev = "???";

	return lev;
}


/* }bvԍ𕶎ɕϊ֐ chrpmn */
function chrpmn(pmn)
{
	pmnc = new Array(4);

    //
	for (i = 0; i <= 3; i++)
	{
		if      (pmn[i] < 10)
			pmnc[i]="00" + pmn[i];
		else if (pmn[i] < 100)
			pmnc[i]="0"  + pmn[i];
		else
			pmnc[i]=""   + pmn[i];
	}

	return pmnc;
}


/* Xe[Wԍ𕶎ɕϊ֐ chrstg */
function chrstg(stg)
{
	stgc = "";
	var keta;

    //(Xe[Wԍ(000,000,000`268,435,455)Xɑĕɂ)
	keta=(stg != 0)?  Math.floor( Math.log(stg) / Math.log(10) ) + 1 : 1;
	for (i = keta ; i < 9; i++)
		stgc += "0";
	stgc += stg;

	return stgc;
}


/* }bvԍڍ׃f[^(EOEՓx)𓱏o֐ pmntodat */
function pmntodat(pmn)
{
	// Added last 4 dat elements
	dat = new Array(0,0,1,0,"",0,"");
	//             | 0                     | 8                     |16                     |24                     |32                     |40                     |48                     |56                     |64                     |72                     |80                     |88                     |96                     |104                    |112                    |120                    |
	dbs = new Array(19, 8,20,29,27, 1, 2, 1,24,22, 2, 4,24, 6,17, 4,45,15,24, 9,10, 9, 7,15,40,12, 2, 3,29, 2,168,4,19,13, 3,15,13,24,13,39,20,37,51,39,29,27,23,15,11,28,38,14,26, 4, 1,16, 3, 2, 2,56,16,18,18,25,23,20,55, 4,29,12, 2,45, 1, 6, 2, 1,18, 3,28,20,23, 4,60,22,48,13, 2,35, 1, 5, 6,32,54, 7,24,22,48,34, 2,13,32, 5, 2,27,13,10, 4, 4,13, 5,18,25,17, 9,44,35, 4,44,30,56, 6,18,57, 4,17, 6,27, 5);
	drg = new Array(32, 3,20,26,18, 4, 1, 2,28, 2,11, 8,17, 2,10, 8,64,11,20,36, 3, 8,12,10,54,18, 1, 1,52, 1,164,4,26,14,10, 9,16, 2, 9,38, 9, 6,12,21, 4,18,22,17,17, 1, 2,48,22,16, 1, 4, 1,16, 6, 6,23, 9,14, 3,26,38,30,24,40, 5,12,45,12, 3,12, 6,20, 3,42,54,43,64,72,20,48,21,13,22,13,17,12,48,32,100,6, 2,45,32, 4,25,36, 4, 4,21,17, 9, 9, 2, 9, 1,16,18,11, 5,36,33, 9,40, 5,48, 2, 9, 1, 8, 9, 3,34, 4);
	ddf = new Array( 0, 2, 1, 1, 2, 1, 3, 3, 2, 1, 2, 0, 1, 3, 2, 2, 2, 1, 1, 3, 1, 1, 2, 2, 2, 3, 3, 3, 2, 1,  3,2, 1, 2, 2, 3, 1, 2, 2, 1, 2, 1, 2, 1, 2, 3, 1, 2, 3, 1, 1, 1, 1, 1, 3, 2, 3, 2, 1, 2, 2, 3, 2, 2, 1, 2, 2, 0, 1, 2, 1, 1, 2, 1, 0, 2, 0, 3, 2, 2, 2, 1, 1, 2, 1, 1, 1, 0, 1, 0, 2, 2, 3, 2, 2, 1, 0, 1, 2, 1, 2, 2, 2, 3, 2, 1, 2, 2, 3, 3, 3, 1, 3, 3, 0, 1, 3, 2, 2, 1, 3, 3, 2, 3, 3, 1, 2, 3);

	for (i = 0; i <= 3; i++)
	{
		dat[0] += dbs[ pmn[i] ];
		dat[1] += drg[ pmn[i] ];
		dat[2] += ddf[ pmn[i] ];
	}

	// Credit for pattern algorithm goes to Melanogaster -> http://boards.gamefaqs.com/gfaqs/user.php?user=567596
	// as described here: http://boards.gamefaqs.com/gfaqs/genmessage.php?board=6742&topic=13335352
        patterns = new Array("Orange/Brown","Green/Turquoise","Orange/Cream","White/Red","Purple/Orange","Blue/Light Blue","Purple/Yellow","Blue/Green","Green/Cream","Orange/Turquoise","Magenta/Green","Blue/Yellow","Purple/Green","Green/Indigo","Turquoise/Magenta","Blue/White");
	dat[3] = pmnc[2]%16;
	dat[4] = patterns[dat[3]];

	// Figured out the emerald algorithm myself, it's fairly simple
	emeralds = new Array("Green","Red","Purple","Blue","Grey","Red","Light Blue","Yellow");
        dat[5] = pmnc[2]%8;
        dat[6] = emeralds[dat[5]];

	if (dat[2] == 13)
		dat[2] = "MAX";
	return dat;
}


/* ʕ\y[W̃\[X֐ writepage */
function writepage()
{
	// Just about a complete rewrite here, everything to english

	document.write("\n<table>\n<tbody>\n<tr><td>");
	if (pnum == 1)
	{
		document.write("Level:</td><td>" + lev + com + "</td></tr>\n<tr><td>");
		document.write("Stage:</td><td>" + stgc + "</td></tr>\n");
	}
	else if (pnum == 2)
	{
		document.write("Stage:</td><td>" + stgc + "</td></tr>\n<tr><td>");
		document.write("Level:</td><td>" + lev + "</td></tr>\n");
	}
	document.write("<tr><td>Code:</td><td>" + cod + "</td></tr>\n");
	document.write("<tr><td>Difficulty: </td><td>" + dat[2] + "</td></tr>\n");
	document.write("<tr><td>Pattern:</td><td><img src=\"pattern" + dat[3] + ".png\" title=\"" + dat[4] + "\" alt=\"" + dat[4] + "\"/></td></tr>\n");
	document.write("<tr><td>Emerald:</td><td><img src=\"emerald" + dat[5] + ".png\" title=\"" + dat[6] + "\" alt=\"" + dat[6] + "\"/></td></tr>\n");
	document.write("<tr><td colspan=\"2\"><img src=\"bluesphere.png\" title=\"Blue Spheres\" alt=\"Blue Spheres\"/> x " + dat[0] + " / ");
	document.write("<img src=\"ring.png\" title=\"Rings\" alt=\"Rings\"/> x " + dat[1] + "</td></tr>\n</tbody>\n</table>\n<table cellspacing=\"0\" cellpadding=\"0\">\n<tbody>\n<tr>");
	picnum=new Array(1,3,1,3,0,2,0,2,1,3,1,3,0,2,0,2);
	picltr=new Array("b","d","b","d","a","c","a","c","b","d","b","d","a","c","a","c");
	if (act=="oneexpmaplevel" || act=="oneexpmapstage" || act=="expmaplist")
	{
		for (i=0; i<4; i++)
			document.write("<td align=\"center\">v #" + pmnc[picnum[i]] + " v</td>");
		document.write("</tr>\n<tr");
		if (usebackground)
			document.write(" style=\"background-image: url('background"+dat[3]+".png');\"");
		document.write(">");
		for (i=0; i<16; i++)
		{
			document.write("<td><img src=\"" + pmnc[picnum[i]] + "-" + picltr[i] + ".png\" alt=\"[Section #" + pmnc[picnum[i]] + "]\"/></td>");
			if ((i+1)%4==0 && i!=15)
			{
				document.write("</tr>\n<tr");
				if (usebackground)
					document.write(" style=\"background-image: url('background"+dat[3]+".png');\"");
				document.write(">");
			}
		}
		document.write("</tr>\n<tr>");
		for (i=4; i<8; i++)
			document.write("<td align=\"center\">^ #" + pmnc[picnum[i]] + " ^</td>");
	}
	else
	{
		for (i=5; i>3; i--)
			document.write("<td align=\"center\">v #" + pmnc[picnum[i]] + " v</td>");
		document.write("</tr>\n<tr");
		if (usebackground)
			document.write(" style=\"background-image: url('background"+dat[3]+".png');\"");
		document.write(">");
		for (i=5; i>1; i--)
		{
			document.write("<td><img src=\"" + pmnc[picnum[i]] + "-" + picltr[i] + ".png\" alt=\"[Section #" + pmnc[picnum[i]] + "]\"/></td>");
			if (i%2==0 && i!=2)
			{
				document.write("</tr>\n<tr");
				if (usebackground)
					document.write(" style=\"background-image: url('background"+dat[3]+".png');\"");
				document.write(">");
			}
		}
		document.write("</tr>\n<tr>");
		for (i=3; i>1; i--)
			document.write("<td align=\"center\">^ #" + pmnc[picnum[i]] + " ^</td>");
	}
	document.write("</tr>\n</tbody>\n</table>");
}



////////////////////////////////////////////////////////////////////////////////

/* vO{[1] x}bv\ */
function analyze1(){
	pnum = 1;
	MIN  = 1;
	MAX  = 134217728;
	// levr is defined in script below
	//levr = document.code1.level.value;
	lev  = Math.floor(levr);

    //͂ꂽxΈȉs
	if (numcheck(levr,lev,MIN,MAX) == 0)
	{

    //R[hEXe[W}bv̌vZ
		cod  = levtocod(lev);
		if (act!="list")
		{
  			pmn  = levtopmn(lev);
			pmnc = chrpmn(pmn);
			stg  = pmntostg(pmn);
			stgc = chrstg(stg);
			dat  = pmntodat(pmn);
		}
		if (lev > 128016000) com = " (and " + (lev-128016000) + ")";
		else com = "";

    //\y[W
		if (act!="list" && act!="verboselist")
		{
			writepage();
			document.write("\n<br/>\n<br/>");
		}
	}
	else
	{
		document.write("Level generation canceled");
	}
}


/* vO{[2] Xe[Wԍ}bv\ */
function analyze2(){
	pnum = 2;
	MIN  = 0;
	MAX  = 268435455;
	// stgr defined in script below
	//stgr = document.code2.stage.value;
	stg  = Math.floor(stgr);

    //͂ꂽxΈȉs
	if (numcheck(stgr,stg,MIN,MAX) == 0)
	{

    //Xe[W}bv̌vZ
		pmn  = stgtopmn(stg);
		if (act!="list")
		{
			stgc = chrstg(stg);
			pmnc = chrpmn(pmn);
			dat  = pmntodat(pmn);
		}
		lev  = pmntolev(pmn);
		cod  = ((isNaN(lev))? "???" : levtocod(lev));

    //\y[W
		if (act!="list" && act!="verboselist")
		{
			writepage();
			document.write("\n<br/>\n<br/>");
		}
	}
	else
	{
		document.write("Level generation canceled");
	}
}